﻿
#targetengine "revisions"


// TODO
// ## UPDATE BOOK AUTOMATICALLY WHEN UPDATING A FILE (check if file belongs to open book)
// # FORCE SAVE ALL FILE IN BOOK!!!! first
// # Save/Load keyboard shortcuts 
// # Finish dialog for saving earlier revision with options
// # update config file gen. add earlier version warning toggle, 
// separate set of scripts for script panel in addition to menu 

// error on opening - disable warning code
// multiple books
// check if open file is in current book
// 
// CHECK FOR REVISION/DRAFT OVERFLOW -- AT 999 automatically update draft and reset R to 0
// BECAUSE OF AUTO MODE
//
// BOOK
//

// var demoMaxR=6;
// var demoMaxD=2;

var version=1;
var autoEnabled=false;
var autoMenu;
var regMenu;
var timer=0;

var myIdleTask;
var onIdleEventListener ;

var regCode;
var userCode="";
var result="";
var theScriptName="";

var autoBackupTime=600000;

var warningFN="";


// sNagString = "UNREGISTERED VERSION";
// sRunString = "Unregistered version\n\nRegistration required at this time";


	//bRegistered=doCopyProtection("SmartRevisions",version);
	bRegistered=true;
	//alert(bRegistered);


// THE MAIN PROCESS
// -----------------------------------------------
//var fTitleReg = "Register SmartRevisions";
var fTitleR = "Update Revision";
var fTitleD = "Update Draft";
var fTitleB = "Update Book Draft";
var fTitleA = "Start Auto Revision";
var fTitlea = "Stop Auto Revision";
if(version>1){
var fTitleER= "Open earlier revision"; //gives 2 options on open: 1) just open from archivel 2) move to main folder
}

var fHandlersReg = {
	'beforeDisplay' : function(ev)
		{
		try{
			ev.target.enabled = (!bRegistered);
			}
		catch(e){notify("RS001: \n"+e,2);}
		},
		
	'onInvoke' : function()
		{
		try{
			register("SmartRevisions");
			}
		catch(e){notify("RS002: \n"+e,2);}
		}
	};

var fHandlersB = {
	'beforeDisplay' : function(ev)
		{
		try{
			ev.target.enabled = (app.books.length>=1);
			}
		catch(e){notify("RS001: \n"+e,2);}
		},
		
	'onInvoke' : function()
		{
		try{
			doUpdateBook();
			}
		catch(e){notify("RS002: \n"+e,2);}
		}
	};

var fHandlersR = {
	'beforeDisplay' : function(event)
		{
		try{
			event.target.enabled = (app.documents.length>0);
			}
		catch(e){notify("RS003: \n"+e,2);}
		},
		
	'onInvoke' : function()
		{
		try{
			doUpdate("Revision");
			}
		catch(e){notify("RS004: \n"+e,15);}
		}
	};
	
var fHandlersD = {
	'beforeDisplay' : function(event)
		{
		try{
			event.target.enabled = (app.documents.length>0);
			}
		catch(e){notify("RS005: \n"+e,2);}
		},
		
	'onInvoke' : function()
		{
		try{
			doUpdate("Draft");
			}
		catch(e){notify("RS006: \n"+e,2);}
		}
	};

var fHandlersA = {
	'beforeDisplay' : function(event)
		{
		try{
			event.target.enabled = (app.documents.length>0);
			}
		catch(e){notify("RS009: \n"+e,2);}
		},
		
	'onInvoke' : function()
		{
		try{
			if(autoEnabled==false){
				autoEnabled=true;
				var myLabelWidth = 130;

var myDialog = app.dialogs.add({name: "AutoBackup Interval"})
with(myDialog.dialogColumns.add()){
            with(borderPanels.add()){
                        with(dialogColumns.add()){
                                    with(dialogRows.add()){
                                                staticTexts.add({staticLabel:"Minutes:", minWidth:myLabelWidth});
                                                myDelay = integerEditboxes.add({editValue:autoBackupTime/60000});
                                    }
                                    
                        }
            }
}
myResult = myDialog.show();
if(myResult==1){
	autoBackupTime=myDelay.editValue*60000;
	}
				autoMenu.remove();
				fMenuInstaller = (function(menuTitle,menuHandlers)
					{
					var menuAction = app.scriptMenuActions.add(menuTitle);

					var event;
					for( event in menuHandlers )
						{
						menuAction.eventListeners.add(event,menuHandlers[event]);
						}

					// 3. Create the menu item
					var fileMenu = app.menus.item("$ID/Main").submenus.item("$ID/&File");
					var refItem = fileMenu.menuItems.item("$ID/Check In...");

					autoMenu=fileMenu.menuItems.add(menuAction,LocationOptions.before,refItem);

					return true;
					})(fTitlea, fHandlersA);
				
				 myIdleTask = app.idleTasks.add({name:"my_idle_task", sleep:autoBackupTime});
				onIdleEventListener = myIdleTask.addEventListener("onIdle", onIdleEventHandler, false);
				}
			else{
				if(autoEnabled==true){
					autoEnabled=false;
					autoMenu.remove();
					fMenuInstaller = (function(menuTitle,menuHandlers)
						{
						var menuAction = app.scriptMenuActions.add(menuTitle);

						var event;
						for( event in menuHandlers )
							{
							menuAction.eventListeners.add(event,menuHandlers[event]);
							}

						// 3. Create the menu item
						var fileMenu = app.menus.item("$ID/Main").submenus.item("$ID/&File");
						var refItem = fileMenu.menuItems.item("$ID/Check In...");

						autoMenu=fileMenu.menuItems.add(menuAction,LocationOptions.before,refItem);

						return true;
						})(fTitleA, fHandlersA);
					//myIdleTask = app.idleTasks.itemByName("my_idle_task");
					if (myIdleTask != null)
					{
						myIdleTask.remove();
					}
					}
				}
			}
		catch(e){notify("RS010: \n"+e,2);}
		}
	};

if(version>1){
var fHandlersER = {
	'beforeDisplay' : function(event)
		{
		try{
			event.target.enabled = (app.documents.length>0 && bArchiveExists(app.activeDocument.filePath)==true);
			}
		catch(e){
			notify(app.activeDocument.filePath);
			notify("RS007: \n"+e,2);
			}
		},
		
	'onInvoke' : function()
		{
		try{
			
			doRevert();
			}
		catch(e){notify("RS008: \n"+e,2);}
		}
	};
}

// install general listener

var myApplicationEventListener = app.eventListeners.add("afterOpen",myFileInfo);
var myApplicationEventListener = app.eventListeners.add("onIdle",checkTime);
   // alert("Listener installed");

  
	

// THE MENU INSTALLER
// -----------------------------------------------
var fMenuInstaller = fMenuInstaller||
(function(menuTitle,menuHandlers)
{
var menuAction = app.scriptMenuActions.add(menuTitle);

var event;
for( event in menuHandlers )
	{
	menuAction.eventListeners.add(event,menuHandlers[event]);
	}

// 3. Create the menu item
var fileMenu = app.menus.item("$ID/Main").submenus.item("$ID/&File");
var refItem = fileMenu.menuItems.item("$ID/Check In...");

fileMenu.menuItems.add(menuAction,LocationOptions.before,refItem);
		
return true;
})(fTitleR, fHandlersR);

// INSTALL DRAFT

fMenuInstaller = (function(menuTitle,menuHandlers)
	{
	var menuAction = app.scriptMenuActions.add(menuTitle);

	var event;
	for( event in menuHandlers )
		{
		menuAction.eventListeners.add(event,menuHandlers[event]);
		}

	// 3. Create the menu item
	var fileMenu = app.menus.item("$ID/Main").submenus.item("$ID/&File");
	var refItem = fileMenu.menuItems.item("$ID/Check In...");

	fileMenu.menuItems.add(menuAction,LocationOptions.before,refItem);

	return true;
	})(fTitleD, fHandlersD);

// INSTALL AUTO
fMenuInstaller = (function(menuTitle,menuHandlers)
	{
	var menuAction = app.scriptMenuActions.add(menuTitle);

	var event;
	for( event in menuHandlers )
		{
		menuAction.eventListeners.add(event,menuHandlers[event]);
		}

	// 3. Create the menu item
	var fileMenu = app.menus.item("$ID/Main").submenus.item("$ID/&File");
	var refItem = fileMenu.menuItems.item("$ID/Check In...");

	autoMenu=fileMenu.menuItems.add(menuAction,LocationOptions.before,refItem);

	return true;
	})(fTitleA, fHandlersA);

// INSTALL REVISION
if(version>1){
fMenuInstaller = (function(menuTitle,menuHandlers)
	{
	var menuAction = app.scriptMenuActions.add(menuTitle);

	var event;
	for( event in menuHandlers )
		{
		menuAction.eventListeners.add(event,menuHandlers[event]);
		}

	// 3. Create the menu item
	var fileMenu = app.menus.item("$ID/Main").submenus.item("$ID/&File");
	var refItem = fileMenu.menuItems.item("$ID/Check In...");

	fileMenu.menuItems.add(menuAction,LocationOptions.before,refItem);

	return true;
	})(fTitleER, fHandlersER);
}

// install Registration
// if(!bRegistered){
// fMenuInstaller = (function(menuTitle,menuHandlers)
// 	{
// 	var menuAction = app.scriptMenuActions.add(menuTitle);

// 	var event;
// 	for( event in menuHandlers )
// 		{
// 		menuAction.eventListeners.add(event,menuHandlers[event]);
// 		}

// 	// 3. Create the menu item
// 	var fileMenu = app.menus.item("$ID/Main").submenus.item("$ID/&File");
// 	var refItem = fileMenu.menuItems.item("$ID/Check In...");

// 	regMenu=fileMenu.menuItems.add(menuAction,LocationOptions.before,refItem);

// 	return true;
// 	})(fTitleReg, fHandlersReg);
// }

// INSTALL BOOK
fMenuInstaller = (function(menuTitle,menuHandlers)
	{
	var menuAction = app.scriptMenuActions.add(menuTitle);	

	var event;
	for( event in menuHandlers )
		{
		menuAction.eventListeners.add(event,menuHandlers[event]);
		}	
	var mainMenu = app.menus.item("$ID/Book Panel Menu");
	var refItem = mainMenu.menuItems.item("$ID/Close Book");

	mainMenu.menuItems.add(menuAction,LocationOptions.AFTER,refItem);	
	return true;
	})(fTitleB, fHandlersB);

//=============

function onIdleEventHandler(){
	if(app.activeDocument.modified){
		doUpdate("Revision");
		}
	}


//========================

function doUpdateR(){doUpdate("Revision");}
function doUpdateD(){doUpdate("Draft");}

function doUpdateBook(){
	if(app.books.length==0)return;
	var myDoc;
	var maxDraft = -1;
	var myBookName=app.activeBook.name;
	var myBookFullName=app.activeBook.fullName;
	var myBookPath=app.activeBook.filePath;
	
	var myBookNameParts=splitBookName(myBookName);
	
	app.activeBook.save();
	
	for( var i = app.activeBook.bookContents.length-1 ; i>=0 ; i-- )
		{
		myDoc=app.activeBook.bookContents[i];
		var myDocName=myDoc.name;
		var myDocNameParts=[]; myDocNameParts=splitDocName(myDocName); 
		var coreFilename= myDocNameParts[0];
		var currentRInt= myDocNameParts[1];
		var currentDraftInt= myDocNameParts[2];
		var newRInt=currentRInt;
		var newDraftInt=currentDraftInt;
		var newRStr=""+currentRInt;
		var newDraftStr=""+currentDraftInt;
		var myFullName=myDoc.fullName;
		var myFilePath=myDoc.filePath;


		var filteredFiles=getFilteredFiles(myFilePath,coreFilename);
		var maxRD=getMaxRD(filteredFiles);

		if(maxDraft<maxRD[1])maxDraft=maxRD[1];
		
		if(myDocNameParts[1]===maxRD[0])continue;
		
		newRInt=maxRD[0];
		newDraftInt=maxRD[1];
		var newRStr=""+newRInt;
		var newDraftStr=""+newDraftInt;
		while(newRStr.length<3){newRStr="0"+newRStr;}
		while(newDraftStr.length<2){newDraftStr="0"+newDraftStr;}
		
		var newFile=myFilePath+"/"+myDocNameParts[0]+" r"+newRStr+" draft "+newDraftStr+".indd";
		myDoc.replace(File(newFile));
		}
		
	if(maxDraft!=myBookNameParts[1]){
		maxDraftStr=""+maxDraft;
		while(maxDraftStr.length<2){maxDraftStr="0"+maxDraftStr;}
		
		newBookName=app.activeBook.filePath+"/"+myBookNameParts[0]+" draft "+maxDraftStr+".indb";
		notify("Renaming book to "+newBookName,1);
		app.activeBook.save(File(newBookName));
		archive(myBookFullName,myBookPath);
		}
	else{
		app.activeBook.save();
		}
	
	}

function doRevert(){
	alert("Reverting");
	// save current dir
	// open file dlg
	// dlg option move to working dir or just open (Open or Revert)
	
	// set current dir
	}

function doUpdate(what){
	var info=[];
 	// var fileScript=GetScriptPath();
 	// var scriptDirectory=fileScript.path;
 	// var configFile=File(scriptDirectory+"/RS_revisions.cfg");
	
 	// theActiveScript=app.activeScript;
 	// thePath=theActiveScript.path;
 	// rootDir=thePath.substr(0,thePath.indexOf("/Scripts/")+9);
 	
 	// configFile=File(rootDir+"RS_SmartRevisions.cfg");
	
	// if(File(configFile).exists){
	// 	info=loadConfigInfo(File(configFile));
	// 	}
	// else{
	// 	info=createConfig(File(configFile));
	// 	}
	
	
	var myDoc=app.activeDocument;
	var myDocName=myDoc.name;
	var myDocNameParts=[]; myDocNameParts=splitDocName(myDocName); 
	
	var coreFilename= myDocNameParts[0];
	var currentRInt= myDocNameParts[1];
	var currentDraftInt= myDocNameParts[2];
	var newRInt=currentRInt;
	var newDraftInt=currentDraftInt;
	var newRStr=""+currentRInt;
	var newDraftStr=""+currentDraftInt;
	
	
	var myFullName=myDoc.fullName;
	var myFilePath=myDoc.filePath;
	
	filteredFiles=getFilteredFiles(myFilePath,coreFilename);
	var maxRD=getMaxRD(filteredFiles);
	

	
	
	switch (what){
		case "Revision": 	newRInt=currentRInt+1;newRStr=""+newRInt;break;
		case "Draft": 		newDraftInt=currentDraftInt+1;newDraftStr=""+newDraftInt;newRInt=currentRInt+1;newRStr=""+newRInt;break;
		}
	
		action=checkNumbersForError(newRInt,newDraftInt,maxRD);
		
		if(action==null)return;
		
		newRInt=action[0];
		newDraftInt=action[1];

	while(newRStr.length<3){newRStr="0"+newRStr;}
	while(newDraftStr.length<2){newDraftStr="0"+newDraftStr;}


	var saveFileName=coreFilename+" r"+newRStr+" draft "+newDraftStr+".indd";
	myDoc.metadataPreferences.documentTitle=saveFileName;
	
	// myDoc.metadataPreferences.author=info[0];
	// myDoc.metadataPreferences.description=info[1];
	var newFile=File(myFilePath+"/"+saveFileName);
//~ 	if(newFile.exists){
//~ 		alert(newFile+" already exists. aborting.");
//~ 		}
//~ 	else{
		//alert("Saving "+myFilePath+"/"+saveFileName);
		myDoc.save(File(myFilePath+"/"+saveFileName));	
		archive(myFullName,myFilePath);
		
//~ 		}
	//if(app.books.length>=1){
		doUpdateBook();
	//	}
	}

function bArchiveExists(theFolder){
	var arcFolder=Folder(theFolder+"/RS_Archive");
	if(arcFolder.exists)return true;
	return false;
	}

function archive(theFile,theFolder){
	var arcFolder=Folder(theFolder+"/RS_Archive");
	var arcFile=File(theFile);
	if(! arcFolder.exists)arcFolder.create();
	MoveFile(arcFile, arcFolder);
	}


function checkNumbersForError(newRInt,newDraftInt,maxRD){
	var maxR=maxRD[0];
	var maxD=maxRD[1];

	if((newRInt>maxR) && (newDraftInt > maxD)) return [newRInt,newDraftInt]; // new draft -- ok
	if(newRInt>maxR) return  [newRInt,newDraftInt]; // new revision
	
		var myWindow = new Window ("dialog", "Warning");
		var myExplainGroup = myWindow.add ("group");
		myExplainGroup.alignment="left";
		hs="Warning: New Revision number "+newRInt+" and New Draft number "+newDraftInt+"\n";
		hs+="indicate the current file is probably NOT the latest revision or draft.\n";
		hs+="Current revision is "+maxR+" and current Draft is "+ maxD+"\n";
		t=myExplainGroup.add ("statictext",undefined,hs,{multiline: true});
		t.characters=60;
		var myButtonGroup = myWindow.add ("group");
		myButtonGroup.alignment = "right";
		myButtonGroup.add ("button", undefined, "OK");
		myButtonGroup.add ("button", undefined, "Cancel");
		if (myWindow.show () == 1){
			return  [newRInt,newDraftInt];
			}
		else{
			return null;
			}
	
	//if((newRInt<=maxR) && (newDraftInt == maxD)) return 2;
	
	return null;
	}

function getFilteredFiles(path,filter){
	var f;
	var r=[];
	
	f=Folder(path);
	l=f.getFiles(filter+" r??? draft ??.indd");
	for(i=0;i<l.length;i++){
		n=l[i].name;
		r.push(n);
		}
	return r;
	}

function returnLatestRevision(ThisFile){
	// call function with the fullName of the document
	// Returns fullName of latest revision or ThisFile
	
	}

function getCurrentFileRD(theFile){
	var maxR=-1;
	var maxD=-1;
		t=theFile;
		x=t.search("r\\d\\d\\d");
		retR=t.substr(x+1,3);
		RInt=parseInt(retR,10);
		if(RInt>maxR)maxR=RInt;
		t=theFile;
		x=t.search("draft \\d\\d");
		retD=t.substr(x+6,2);
		DInt=parseInt(retD,10);
		if(DInt>maxD)maxD=DInt;
		return [maxR,maxD];
	}

function getMaxRD(filteredFiles){
	var maxR=-1;
	var maxD=-1;
	
	for(i=0;i<filteredFiles.length;i++){
		t=filteredFiles[i];
		x=t.search("r\\d\\d\\d");
		retR=t.substr(x+1,3);
		RInt=parseInt(retR,10);
		if(RInt>maxR)maxR=RInt;
		}
	for(i=0;i<filteredFiles.length;i++){
		t=filteredFiles[i];
		x=t.search("draft%20\\d\\d");
		retD=t.substr(x+8,2);
		DInt=parseInt(retD,10);
		if(DInt>maxD)maxD=DInt;
		}
	return [maxR,maxD];
	}

function splitBookName(s){
	//alert("Splitting "+s);
		
	x=s.search(" draft \\d\\d");	
	if(x>-1){
			retD=s.substr(x+7,2);
			DInt=parseInt(retD,10);
			tempS=s.slice(0,x)+s.slice(x+9);
			s=tempS;
			}
		else{
			DInt=0;
			}
		x=s.search(".indb");
		tempS=s.slice(0,x);
		s=tempS;
		//alert([s,RInt,DInt]);
		return [s,DInt];
	}


function splitDocName(s){
	//alert("Splitting "+s);
	x=s.search(" r\\d\\d\\d");
	if(x>-1){
			retR=s.substr(x+2,3);
			RInt=parseInt(retR,10);
			tempS=s.slice(0,x)+s.slice(x+5);
			s=tempS;
			}
		else{
			RInt=0;
			}
		
	x=s.search(" draft \\d\\d");	
	if(x>-1){
			retD=s.substr(x+7,2);
			DInt=parseInt(retD,10);
			tempS=s.slice(0,x)+s.slice(x+9);
			s=tempS;
			}
		else{
			DInt=0;
			}
		x=s.search(".indd");
		tempS=s.slice(0,x);
		s=tempS;
		//alert([s,RInt,DInt]);
		return [s,RInt,DInt];
	}


function loadConfigInfo(cfgFile){
	t=[];
	cfgFile.open("r");	
	t[0]=cfgFile.readln();
	t[1]=cfgFile.readln();

	cfgFile.close();
	return t;
	}

function createConfig(cfgFile){
	t=[];
	var myData = myInput ();
	if (!cfgFile.exists) {
    // make new log file
    cfgFile.open("w");
	cfgFile.encoding="UTF-8"
    cfgFile.close();
	}
  cfgFile.open("e");
  cfgFile.seek(0,2);
  cfgFile.write(myData[0]+"\n" + myData[1]+"\n[None]\n[None]\n[None]\n");
  cfgFile.close();
  return myData;
	
// rest of the script
		function myInput () {
		var myWindow = new Window ("dialog", "Input User Information");
		var myInputGroup = myWindow.add ("group");
		myInputGroup.alignment="left";
		myInputGroup.add ("statictext", undefined, "User:");
		var myText = myInputGroup.add ("edittext", undefined, "User Name");
		myText.characters = 40;
		myText.active = true;
		var myInputGroup2 = myWindow.add ("group");
		myInputGroup2.alignment="left";
		myInputGroup2.add ("statictext", undefined, "Info:");
		var myText2 = myInputGroup2.add ("edittext", undefined, "Description");
		myText2.characters = 60;
		myText2.active = true;
		var myButtonGroup = myWindow.add ("group");
		myButtonGroup.alignment = "right";
		myButtonGroup.add ("button", undefined, "OK");
		myButtonGroup.add ("button", undefined, "Cancel");
		
		if (myWindow.show () == 1) {
			t[0]=myText.text;
			t[1]=myText2.text;
			return t;
			}
		else{
			t[0]=myText.text;
			t[1]=myText2.text;
			return t;
			}
		exit ();
		}
	}

function GetScriptPath() {
    try{
        return app.activeScript;
    }
    catch(err){
        return new File(err.fileName);
    }
}

function notify(s,sec){
	var dlog = new Window("palette");
	dlog.size = [520,100];

	st=dlog.add("statictext", undefined , s,{multiline: true});
	st.characters=80;
	dlog.show();
	dlog.update();
	$.sleep(sec*1000);
	dlog.close();
	}

function myFileInfo(myEvent){
	
	var myDoc=myEvent.parent;
	var myDocName=myDoc.name;
	var myDocNameParts=[]; myDocNameParts=splitDocName(myDocName); 
	
	if(!autoEnabled){notify("Auto-Revise is OFF in case you want to turn it on.",2);}
	
	//alert("Opened "+myDocName);
	
	var coreFilename= myDocNameParts[0];
	var currentRInt= myDocNameParts[1];
	var currentDraftInt= myDocNameParts[2];
	var myFullName=myDoc.fullName;
	var myFilePath=myDoc.filePath;
	
	if(warningFN==myFullName)return;
	warningFN=myFullName;
	
	//alert("Path "+myFilePath);
	
	filteredFiles=getFilteredFiles(myFilePath,coreFilename);
	
	//alert(filteredFiles);
	
	var maxRD=getMaxRD(filteredFiles);
		
	if(currentRInt==maxRD[0])return;
	
	if(maxRD[0]==-1)return;
	
	var warning="WARNING: File "+myDocName+ " is NOT the latest revision.\n\n";
	warning+="The current file is Revision "+currentRInt+", and the latest Revision is "+maxRD[0]+".\n\n";
	warning+="Just letting you know.";
	notify(warning,5);


}


function MoveFile(myFile, myFolder) {  
    
    if (!myFile instanceof File) {alert("a");return false;  }
    if (!myFolder instanceof Folder ) {alert("b");return false;  }
    if (!myFile.exists) {alert("c");return false;  }
    if (!myFolder.exists) {alert(myFolder+" - d");return false;  }

if (!myFile instanceof File || !myFolder instanceof Folder || !myFile.exists || !myFolder.exists) {alert("1");return false;  }
    var myMovedFile = new File(myFolder.absoluteURI + "/" + myFile.name);  
    //if (myMovedFile.exists) {alert("2");return false;  }
    if (File.fs == "Windows")  {  
        var myVbScript = 'Set fs = CreateObject("Scripting.FileSystemObject")\r';  
        myVbScript +=  'fs.MoveFile "' + myFile.fsName + '", "' + myFolder.fsName + '\\"';  
        app.doScript(myVbScript, ScriptLanguage.visualBasic);  
    }  
    else if (File.fs == "Macintosh") {  
        var myAppleScript =   
        'tell application "Finder"\r' +  
        'move POSIX file "' + myFile.fsName + '"  to POSIX file "' + myFolder.fsName + '" with replacing\r' +  
        'end tell\r'  
        app.doScript(myAppleScript, ScriptLanguage.applescriptLanguage);  
    }  
    if (myMovedFile.exists) {  
        return true;  
    }  
    else {  
        return false;  
    }  
}  

function checkTime(){
	t=timeDiff.getCurrentTime();
	alert(t);
	if(t>60000)alert("idle");
	timeDiff.setStartTime();
	}

function doRegister(){
	alert("Registeration");
	}

//=========================


function doCopyProtection(programname,ver){ // return "ABORT" - "DEMO" - "REG"
	
	var theScriptName=programname;
//~ 	if(theScriptName.indexOf(".jsxbin")==-1){
//~ 		//alert("Run compiled version");
//~ 		return "JSX";	
//~ 		}
	
	theActiveScript=app.activeScript;
	thePath=theActiveScript.path;
	rootDir=thePath.substr(0,thePath.indexOf("/Scripts/")+9);
	regFile=File(rootDir+programname+".reg");

var value = programname+"::"+app.serialNumber;
result=MD5(value);


userCode=readReg(regFile);	
	
	var bRegistered=bIsRegistered();
	
	return bRegistered;
	
	if(app.documents.length==0){
		if(bRegistered){
			alert(theScriptName+" Registered Version "+ver+"\nCopyright © 2017 by Akiva Atwood\nDistributed by Renana Scripts\nhttps://www.renanascripts.com\n\nNo documents open");
			return true;
			}
		}
	else{//doc open
		if(bRegistered)return true;
		}
	return false;
	}

function bIsRegistered(){ // returns true or false
	return (userCode==result);
	}


function getRegisteredCode(prog){
	var myValue = prog+"::"+app.serialNumber;
	return MD5(myValue);
	}



// PRIVATE FUNCTIONS

function MD5(s){function L(k,d){return(k<<d)|(k>>>(32-d))}function K(G,k){var I,d,F,H,x;F=(G&2147483648);H=(k&2147483648);I=(G&1073741824);d=(k&1073741824);x=(G&1073741823)+(k&1073741823);if(I&d){return(x^2147483648^F^H)}if(I|d){if(x&1073741824){return(x^3221225472^F^H)}else{return(x^1073741824^F^H)}}else{return(x^F^H)}}function r(d,F,k){return(d&F)|((~d)&k)}function q(d,F,k){return(d&k)|(F&(~k))}function p(d,F,k){return(d^F^k)}function n(d,F,k){return(F^(d|(~k)))}function u(G,F,aa,Z,k,H,I){G=K(G,K(K(r(F,aa,Z),k),I));return K(L(G,H),F)}function f(G,F,aa,Z,k,H,I){G=K(G,K(K(q(F,aa,Z),k),I));return K(L(G,H),F)}function D(G,F,aa,Z,k,H,I){G=K(G,K(K(p(F,aa,Z),k),I));return K(L(G,H),F)}function t(G,F,aa,Z,k,H,I){G=K(G,K(K(n(F,aa,Z),k),I));return K(L(G,H),F)}function e(G){var Z;var F=G.length;var x=F+8;var k=(x-(x%64))/64;var I=(k+1)*16;var aa=Array(I-1);var d=0;var H=0;while(H<F){Z=(H-(H%4))/4;d=(H%4)*8;aa[Z]=(aa[Z]| (G.charCodeAt(H)<<d));H++}Z=(H-(H%4))/4;d=(H%4)*8;aa[Z]=aa[Z]|(128<<d);aa[I-2]=F<<3;aa[I-1]=F>>>29;return aa}function B(x){var k="",F="",G,d;for(d=0;d<=3;d++){G=(x>>>(d*8))&255;F="0"+G.toString(16);k=k+F.substr(F.length-2,2)}return k}function J(k){k=k.replace(/rn/g,"n");var d="";for(var F=0;F<k.length;F++){var x=k.charCodeAt(F);if(x<128){d+=String.fromCharCode(x)}else{if((x>127)&&(x<2048)){d+=String.fromCharCode((x>>6)|192);d+=String.fromCharCode((x&63)|128)}else{d+=String.fromCharCode((x>>12)|224);d+=String.fromCharCode(((x>>6)&63)|128);d+=String.fromCharCode((x&63)|128)}}}return d}var C=Array();var P,h,E,v,g,Y,X,W,V;var S=7,Q=12,N=17,M=22;var A=5,z=9,y=14,w=20;var o=4,m=11,l=16,j=23;var U=6,T=10,R=15,O=21;s=J(s);C=e(s);Y=1732584193;X=4023233417;W=2562383102;V=271733878;for(P=0;P<C.length;P+=16){h=Y;E=X;v=W;g=V;Y=u(Y,X,W,V,C[P+0],S,3614090360);V=u(V,Y,X,W,C[P+1],Q,3905402710);W=u(W,V,Y,X,C[P+2],N,606105819);X=u(X,W,V,Y,C[P+3],M,3250441966);Y=u(Y,X,W,V,C[P+4],S,4118548399);V=u(V,Y,X,W,C[P+5],Q,1200080426);W=u(W,V,Y,X,C[P+6],N,2821735955);X=u(X,W,V,Y,C[P+7],M,4249261313);Y=u(Y,X,W,V,C[P+8],S,1770035416);V=u(V,Y,X,W,C[P+9],Q,2336552879);W=u(W,V,Y,X,C[P+10],N,4294925233);X=u(X,W,V,Y,C[P+11],M,2304563134);Y=u(Y,X,W,V,C[P+12],S,1804603682);V=u(V,Y,X,W,C[P+13],Q,4254626195);W=u(W,V,Y,X,C[P+14],N,2792965006);X=u(X,W,V,Y,C[P+15],M,1236535329);Y=f(Y,X,W,V,C[P+1],A,4129170786);V=f(V,Y,X,W,C[P+6],z,3225465664);W=f(W,V,Y,X,C[P+11],y,643717713);X=f(X,W,V,Y,C[P+0],w,3921069994);Y=f(Y,X,W,V,C[P+5],A,3593408605);V=f(V,Y,X,W,C[P+10],z,38016083);W=f(W,V,Y,X,C[P+15],y,3634488961);X=f(X,W,V,Y,C[P+4],w,3889429448);Y=f(Y,X,W,V,C[P+9],A,568446438);V=f(V,Y,X,W,C[P+14],z,3275163606);W=f(W,V,Y,X,C[P+3],y,4107603335);X=f(X,W,V,Y,C[P+8],w,1163531501);Y=f(Y,X,W,V,C[P+13],A,2850285829);V=f(V,Y,X,W,C[P+2],z,4243563512);W=f(W,V,Y,X,C[P+7],y,1735328473);X=f(X,W,V,Y,C[P+12],w,2368359562);Y=D(Y,X,W,V,C[P+5],o,4294588738);V=D(V,Y,X,W,C[P+8],m,2272392833);W=D(W,V,Y,X,C[P+11],l,1839030562);X=D(X,W,V,Y,C[P+14],j,4259657740);Y=D(Y,X,W,V,C[P+1],o,2763975236);V=D(V,Y,X,W,C[P+4],m,1272893353);W=D(W,V,Y,X,C[P+7],l,4139469664);X=D(X,W,V,Y,C[P+10],j,3200236656);Y=D(Y,X,W,V,C[P+13],o,681279174);V=D(V,Y,X,W,C[P+0],m,3936430074);W=D(W,V,Y,X,C[P+3],l,3572445317);X=D(X,W,V,Y,C[P+6],j,76029189);Y=D(Y,X,W,V,C[P+9],o,3654602809);V=D(V,Y,X,W,C[P+12],m,3873151461);W=D(W,V,Y,X,C[P+15],l,530742520);X=D(X,W,V,Y,C[P+2],j,3299628645);Y=t(Y,X,W,V,C[P+0],U,4096336452);V=t(V,Y,X,W,C[P+7],T,1126891415);W=t(W,V,Y,X,C[P+14],R,2878612391);X=t(X,W,V,Y,C[P+5],O,4237533241);Y=t(Y,X,W,V,C[P+12],U,1700485571);V=t(V,Y,X,W,C[P+3],T,2399980690);W=t(W,V,Y,X,C[P+10],R,4293915773);X=t(X,W,V,Y,C[P+1],O,2240044497);Y=t(Y,X,W,V,C[P+8],U,1873313359);V=t(V,Y,X,W,C[P+15],T,4264355552);W=t(W,V,Y,X,C[P+6],R,2734768916);X=t(X,W,V,Y,C[P+13],O,1309151649);Y=t(Y,X,W,V,C[P+4],U,4149444226);V=t(V,Y,X,W,C[P+11],T,3174756917);W=t(W,V,Y,X,C[P+2],R,718787259);X=t(X,W,V,Y,C[P+9],O,3951481745);Y=K(Y,h);X=K(X,E);W=K(W,v);V=K(V,g)}var i=B(Y)+B(X)+B(W)+B(V);return i.toLowerCase()};
	
	//
// REG RUN AND NAG CODE
//


function register(scriptName){
			var send=false;
			var buy=false;
			code="";
			var myWindow = new Window ("dialog", theScriptName+" Registration");
			myWindow.alignChildren = "right";
			var myInputGroup = myWindow.add ("group");
			myInputGroup.add ("statictext", undefined, "Serial Number:");
			var mySN = myInputGroup.add ("statictext", undefined, "");
			mySN.characters = 80;
			mySN.active = true;
			mySN.text=scriptName+"::"+app.serialNumber;
			
			
			
			var myInputGroup2 = myWindow.add ("group");
			myInputGroup2.add ("statictext", undefined, "Paste Registration Code:");
			var myText = myInputGroup2.add ("edittext", undefined, "");
			myText.characters = 80;
			myText.active = true;
			
			var myButtonGroup = myWindow.add ("group");
			myButtonGroup.alignment = "right";
			buyButton=myButtonGroup.add ("button", undefined, "Buy SmartRevisions");
			sendButton=myButtonGroup.add ("button", undefined, "Send Registration eMail");
			myButtonGroup.add ("button", undefined, "OK");
			myButtonGroup.add ("button", undefined, "Cancel");
			
			buyButton.onClick = function(){
				buy=true;
				myWindow.close();
				}
			
			sendButton.onClick = function(){
				send=true;
				code=scriptName+"::"+app.serialNumber;
				myWindow.close();
				}
			if(myWindow.show ()==1){r=myText.text;if(r==result){
					writeRegToFile(regFile,r,"000","000");
					alert("Thank you for registering");
					regMenu.remove();
					bRegistered=true;
					}else{if(!buy)alert("Reg Code Error");}} // end of SHOW WINDOW
			
			if(buy){myWindow.close();goToURL ("https://www.renanascripts.com/smartrevision");}
			if(send)goToURL ("mailto:raphael@renanadigital.com?subject="+scriptName+"%20registration&body="+code);
			return;
			}// end of demo mode
		
function goToURL (theURL)
   {
     var aDoc = app.documents.add (false);
     var myDest = aDoc.hyperlinkURLDestinations.add (theURL);
     myDest.showDestination ();
     aDoc.close (SaveOptions.no);
     }		
		

function GetFileName(fileName) {
	var str = "";
	var res = fileName.lastIndexOf(".");
	if (res == -1) {
		str = fileName;
	}
	else {
		str = fileName.substr(0, res);
	}
	return str;
}

function readReg(theLog){
	if (!theLog.exists) {
		theLog.open("w");
		theLog.encoding="UTF-8";
		theLog.writeln("01234567890000000000000000000000");
		theLog.close();
		}
	theLog.open("r");
	r1=theLog.readln();
	theLog.close();
	return r1;
	}


function writeRegToFile(theLog,result,nag,run){
	//alert(result);
    if ( theLog.open('w') )
        {
		theLog.encoding="UTF-8";
		theLog.writeln(result);
		theLog.close();
        }
	}

//
// TIMING CODE
//
//~ var timeDiff = {
//~     setStartTime:function (){d = new Date(); time  = d.getTime();},
//~     getDiff:function (){d = new Date(); t = d.getTime() - time; time = d.getTime(); return t;}
//~ };



//~ // start timer
//~ timeDiff.setStartTime();
//~  
//~ // do some stuff
//~ for(var i = 0; i < 10000000; i++){}
//~  
//~ // get result
//~ alert("Script execution time: " + timeDiff.getDiff() / 1000 + " seconds", "IndiSnip /// Scipt execution time");
//~ (Multiple times)

//~ 17
//~ // start timer
//~ timeDiff.setStartTime();
//~  
//~ // do some stuff [part 1]
//~ for(var i = 0; i < 10000000; i++){}
//~  
//~ // get result 1
//~ var part1 = timeDiff.getDiff();
//~  
//~ // do some stuff [part 2]
//~ for(var i = 0; i < 10000000; i++){}
//~  
//~ // get result 2
//~ var part2 = timeDiff.getDiff();
//~  
//~ // get result
//~ alert(part1 + " /// " + part2, "IndiSnip /// Scipt execution time");